Subject: SUA-09: SCCP Connections and TCAP Transactions

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 28 Dec 2001 14:49:58 -0600

John,

Please consider the following changes to replace the "label"
mechanism with a similar "registration" mechanism.  This
"registration" mechanism will permit decoupled operation
across multiple SGs as STPs and will also permit dynamic
assignment of TCAP transaction and SCCP connections to AS
across multiple SGs.  The changes are relatively minor.

--brian

--- sua-09	Thu Nov 29 12:39:52 2001
+++ sua-09.regmods	Fri Dec 28 14:28:12 2001
@@ -588,18 +588,19 @@ 1.5 Internal Functions Provided in the S
    key information available. The destination might be the end SUA node 
    or a SUA relay node. The Routing Keys reference an Application 
    Server, which will have one or more ASPs processing traffic for the 
    AS.  The availability and status of the ASPs is handled by SUA ASP 
    management messages. 
     
    Possible SS7 address/routing information that comprise a Routing Key 
    entry includes, for example, OPC, DPC, SIO found in the MTP3 routing 
-   label, SCCP subsystem number, or Transaction ID. IP addresses and 
-   hostnames can also be used as Routing Key Information. 
+   label, SCCP subsystem number, Source and Destination Local Reference,
+   or Transaction ID. IP addresses and hostnames can also be used as
+   Routing Key Information. 
     
    It is expected that the routing keys be provisioned via a MIB, 
    dynamic registration or external process, such as a database.  

 Loughney (editor)                                           [Page 10]
 
@@ -1048,18 +1049,16 @@ 3.1 Common Message Header 
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
      |                        Message Length                         | 
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
      |                         Message Data                          | 
     
    Note that the 'data' portion of SUA messages SHALL contain SCCP-User 
    data, not the encapsulated SCCP message. 
     
-   Optional parameters can only occur at most once in an SUA message. 
-    
 3.1.1 SUA Protocol Version  
     
    The version field (ver) contains the version of the SUA adaptation 
    layer.  The supported versions are:  
     
      1   SUA version 1.0  
     
 3.1.2 Message Classes 
@@ -2659,26 +2658,16 @@ 3.6.1 ASP Active (ACTIVE) 
       |           Tag = 0x000B        |             Length            | 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
       |                       Traffic Mode Type                       | 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
       |           Tag = 0x0006        |             Length            | 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
       /                       Routing Context                         / 
       \                                                               \ 
-      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
-      |          Tag = 0x0119         |             Length            | 
-      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
-      |                           TID Label                           | 
-      +-------------------------------+-------------------------------+ 
-      |          Tag = 0x011A         |             Length            | 
-      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
-      |                           DRN Label                           | 
-      +-------------------------------+-------------------------------+ 
-      |           Tag = 0x0004        |             Length            | 
  
 Loughney (editor)                                           [Page 44]

 Internet Draft       SS7 SCCP-User Adaptation Layer  November 21, 2001 
@@ -2686,18 +2675,16 @@ 3.6.1 ASP Active (ACTIVE) 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
       /                          Info String                          / 
       \                                                               \ 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
     
    Parameters 
      Traffic Mode Type   Optional 
      Routing Context     Optional 
-     TID Label           Optional 
-     DRN Label           Optional 
      Info String         Optional 
     
 3.6.2 ASP Active Ack (ACTIVE ACK) 
     
    The ASPAC Ack message is used to acknowledge an ASP-Active message  
    received from a remote SUA peer. 
     
    The format for the ACTIVE Ack message is as follows: 
@@ -3304,17 +3291,16 @@ 3.9.12 Error Code 
        Invalid Parameter Value                         0x11   
        Parameter Field Error                           0x12 
        Unexpected Parameter                            0x13 
        Destination Status Unknown                      0x14 
        Invalid Network Appearance                      0x15 
        Missing Parameter                                                         
 0x16 
        Routing Key Change Refused                      0x17 
-       Invalid loadsharing Label                       0x18 
     
    Please note that values marked with * are not directly supported by 
    SUA, but are used by other User Adaptation Layers (IUA, M2UA, M3UA, 
    etc.). 
          
    The "Invalid Version" error would be sent if a message was received 
    with an invalid or unsupported version.  The Error message would 
    contain the supported version in the Common header.  The Error 
@@ -3617,18 +3603,20 @@ 3.10 SUA-Specific parameters  
    Address Range                        0x0111 
    Correlation ID                       0x0112 
    Importance                           0x0113 
    Message Priority                     0x0114 
    Protocol Class                       0x0115 
    Sequence Control                     0x0116 
    Segmentation                         0x0117 
    SMI                                  0x0118 
-   TID Label                            0x0119 
-   DRN Label                            0x011A 
+   Orig Transaction Id                  0x0119 
+   Dest Transaction Id                  0x011A 
+   RN Range                             0x011B 
+   TID Range                            0x011C 
     
    Destination/Source Address Sub-Parameters 
    =========================================== 
    Global Title                         0x8001  
    Point Code                           0x8002 
    Subsystem Number                     0x8003 
    IPv4 Address                         0x8004 
    Hostname                             0x8005           
@@ -4293,16 +4281,22 @@ 3.10.14 Routing Key 
    The Key field contains the following parameters: 
     
         Parameter 
            Traffic Mode Type          Optional 
            Network Appearance         Optional *1 
            Source Address             Optional 
            Destination Address        Optional 
            Address Range              Optional 
+           SRN                        Optional
+           DRN                        Optional
+           Orig Transaction Id        Optional
+           Dest Transaction Id        Optional
+           RN Range                   Optional
+           TID Range                  Optional
     
    Note 1: The Network Appearance parameter must be included in the 
            Routing Key when the ASP is able to register in                                                                     
            multiple SS7 Network contexts. 
     
 3.10.15 Registration Result 
     
       0                   1                   2                   3 
@@ -4597,62 +4591,103 @@ 3.10.24 SMI 
      0x00     Reserved/Unknown 
      0x01     Solitary 
      0x02     Duplicated 
      0x03     Triplicated 
      0x04     Quadruplicated 
      ...      ... 
      0xff     Unspecified 
     
-3.10.25 TID Label 
+3.10.25 Orig Transaction Id
     
        0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
       |          Tag = 0x0119         |            Length = 8         | 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
-      |     start     |      end      |         label value           | 
-      +---------------+---------------+-------------------------------+ 
-    
-   The Start parameter is the start position of label, between 0 (LSB) 
-   and 31 (MSB). 
-    
-   The End parameter is the end position of label, between 0 (LSB) and 
-   31 (MSB). 
+      |                        Transaction Id                         | 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
     
-   Label value is a 16-bit interger, which is unique across an AS. 
+   Transaction Id (3.1/Q.773)
     
-3.10.26 DRN Label 
+   The field is coded with the value of the OrigTransactionID parameter
+   associated with a TCAP Transaction Portion. (See Q.773)  The
+   Transaction Id parameter is used in the REG REQ message to register
+   an Application Server for a Transaction Id or range of Transaction
+   Ids.
 
+3.10.25 Dest Transaction Id
 
+       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
+      |          Tag = 0x011A         |            Length = 8         | 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
+      |                        Transaction Id                         | 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
 
+   Transaction Id (3.1/Q.773)
 
+   The field is coded with the value of the DestTransactionID parameter
+   associated with a TCAP Transaction Portion. (See Q.773)  The
+   Transaction Id parameter is used in the REG REQ message to register
+   an Application Server for a Transaction Id or range of Transaction
+   Ids.
  
 Loughney (editor)                                           [Page 76]

 Internet Draft       SS7 SCCP-User Adaptation Layer  November 21, 2001 

+3.10.26 RN Range 
+    
        0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
-      |          Tag = 0x011A         |            Length = 8         | 
+      |          Tag = 0x011B         |             Length            | 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
+      \                         RN parameters(s)                      \ 
+      /                                                               / 
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
-      |     start     |      end      |         label value           | 
-      +---------------+---------------+-------------------------------+ 
     
-   The Start parameter is the start position of label, between 0 (LSB) 
-   and 23 (MSB). 
+   RN field:
     
-   The End parameter is the end position of label, between 0 (LSB) and 
-   23 (MSB). 
+   The RN field can contain the following parameters:
+
+   Parameter
+     SRN                          Optional *1
+     DRN                          Optional *1
     
-   Label value is a 16-bit interger, which is unique across an AS. 
+   Note 1:  The RN field must contain pairs of SRN or pairs of DRN
+           parameters but MUST NOT mix SRN and DRN parameters in the
+           same RN field.
+
+3.10.27 TID Range
+
+       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1  
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
+      |          Tag = 0x011C         |             Length            | 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
+      \                        TID parameters(s)                      \ 
+      /                                                               / 
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
+
+   TID field:
+
+   The TID field can contain the following parameters:
+
+   Parameter
+     Orig Transaction Id           Optional *1
+     Dest Transaction Id           Optional *1
+
+   Note 1:  The TID field must contain pairs of Orig Transaction Id or
+           pairs of Dest Transaction Id parameters but MUST NOT mix
+           Orig Transaction Id or Dest Transaction Id parameters in the
+           TID field.
     
 4. Procedures 
     
    The SUA layer needs to respond to various local primitives it 
    receives from other layers as well as the messages that it receives 
    from the peer SUA layer.  This section describes the SUA procedures 
    in response to these events. 
     
@@ -5935,78 +5970,77 @@ 4.7.2 Support for Loadsharing 
    messages other than CR is not required. 
     
    If these assumptions cannot be made, both SG and ASP should support 
    the following general procedure in a loadsharing environment. 
 
 4.7.2.1 Association Setup, ASP going active 
     
    After association setup and registration, an ASP normally goes active 
-   for each AS it registered for. In the ASPAC message, the ASP includes 
-   a TID and/or DRN Label Parameter, if applicable for the AS in 
-   question. All the ASPs within the AS must specify a unique label at a 
-   fixed position in the TID or DRN parameter. The same ASPAC message is 
-   sent to each SG used for interworking with the SS7 network. 
+   for each AS it registered for.  The same ASPAC message is sent to each
+   SG used for interworking with the SS7 network. 
     
    The SG builds, per RK, a list of ASPs that have registered for it. 
    The SG can now build up and update a distribution table for a certain 
    Routing Context, any time the association is (re-)established and the 
-   ASP goes active. The SG has to perform some trivial plausibility 
-   checks on the parameters: 
-    
-   - Start and End parameters values are between 0 and 31 for TID. 
-   - Start and End parameters values are between 0 and 23 for DRN  
-   - 0 < (Start - End + 1) <= 16 (label length maximum 16-bit) 
-   - Start values are the same for each ASP within a RC 
+   ASP goes active.
  
 Loughney (editor)                                           [Page 98]

 Internet Draft       SS7 SCCP-User Adaptation Layer  November 21, 2001 
  
-   - End values are the same for each ASP within a RC  
-   - TID and DRN Label values must be unique across the RC 
-    
-   If any of these checks fail, the SG refuses the ASPAC request, with 
-   an error, "Invalid loadsharing label." 
-    
 4.7.3 Routing and message distribution at the SG 
 
 4.7.3.1 TCAP traffic 
     
    Messages not containing a destination (or "responding") TID, i.e. 
-   Query, Begin, Unidirectional, are loadshared among the available 
-   ASPs. Any scheme permitting a fair load distribution among the ASPs 
-   is allowed (e.g. round robin). 
-    
-   When a destination TID is present, the SG extracts the label and 
-   selects the ASP that corresponds with it. 
+   Query, Begin, Unidirectional, are directed to an Application Server
+   by the Address Mapping Function using a Routing Key that does not
+   contain a Transaction Id element.
+   
+   If an ASP is not available in this case, the SG may generate (X)UDTS
+   "routing failure", if the return option is used.  
+   
+   Messages containting a Transaction Id are directed to an Application
+   Server by the Address Mapping Function using a Routing Key that
+   contains the approriate Transaction Id or Transaction Id range
+   element.
     
-   If an ASP is not available, the SG may generate (X)UDTS "routing 
-   failure", if the return option is used.  
+   If an ASP is not available in this case, the SG may generate a TCAP
+   P-Abort.
 
 4.7.3.2 SCCP Connection Oriented traffic 
     
-   Messages not containing a destination reference number (DRN), i.e. a 
-   Connection Request, MAY be loadshared among the available ASPs. The 
-   load distribution mechanism is an implementation issue. When a DRN is 
-   present, the SG extracts the label and selects the ASP that 
-   corresponds with it. If an ASP is not available, the SG discards the 
-   message. 
+   Messages not containing a destination (or "source") reference number
+   (DRN or SRN), i.e. a Connect Request, are directed to an Application
+   Server by the Address Mapping Function using a Routing Key that does
+   not contain a reference number element.
+   
+   If an ASP is not available in this case, the SG may generate (X)UDTS
+   "routing failure", if the return option is used.  
+
+   Messages containing a reference number are directed to an Application
+   Server by the Address Mapping Function using a Routing Key that
+   contains the appropriate reference number or reference number range
+   element.
+
+   If an ASP is not available in this case, the SG may generate a ER
+   "unassigned local reference".
     
 4.7.4 Multiple SGs, SUA Relay Function 
     
-   It is important that each ASP send its unique label (within the AS) 
-   to each SGP. For a better robustness against association failures, 
-   the SGs MAY cooperate to provide alternative routes towards an ASP. 
-   Mechanisms for SG cooperation/co-ordination are outside of the scope 
-   of this document. 
+   Where multiple SGs are provided acting as STPs in the SS7 network,
+   an ASP may configure or register and activate an Application Server,
+   Routing Context and Routing Key containing either the same TCAP
+   Transaction Id (TID/Range) or the same SCCP Connection Ids (RN/Range)
+   with both SGs.
     
 5 Examples of SUA Procedures 
  
    The following sequence charts overview the procedures of SUA.  These 
    are meant as examples, they do not, in and of themselves, impose 
    additional requirements upon an instance of SUA. 
     
 5.1 SG Architecture 

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to [email-masked]